/**
 * @file
 *
 * @brief Invokes the internal error handler with is internal set to false.
 *
 * @ingroup ClassicFatal
 */

/*
 * Copyright (c) 2012 embedded brains GmbH.  All rights reserved.
 *
 *  embedded brains GmbH
 *  Obere Lagerstr. 30
 *  82178 Puchheim
 *  Germany
 *  <rtems@embedded-brains.de>
 *
 * The license and distribution terms for this file may be
 * found in the file LICENSE in this distribution or at
 * http://www.rtems.com/license/LICENSE.
 */

#if HAVE_CONFIG_H
  #include "config.h"
#endif

#include <rtems/fatal.h>

void rtems_fatal(
  rtems_fatal_source source,
  rtems_fatal_code error
)
{
  _Internal_error_Occurred( source, false, error );
}
